function fixBoom()
{
	discoverFile("Add-ons/Weapon_Better_Boombelt.zip");
	exec("Add-ons/Weapon_Better_Boombelt/server.cs");
}



exec("./supports.cs");

if(requireAddOn("Weapon_Rocket_Launcher") == false || requireAddOn("Sound_Beeps") == false)
	return false;


function boombelt_registerImage(%n)
{
	datablock ParticleData(boombelt_temp) //make a fake particle based off grass to help client download images
	{
		textureName          = "Add-ons/Weapon_Better_Boombelt/"@ %n @".png";
		dragCoefficient      = 10.0;
		windCoefficient      = 0.0;
		gravityCoefficient   = 0.0; 
		inheritedVelFactor   = 0.0;
		lifetimeMS           = 20000;
		lifetimeVarianceMS   = 0;
		useInvAlpha = true;
		spinRandomMin = 0.0;
		spinRandomMax = 0.0;

		colors[0]     = "1 1 1 0";
		colors[1]     = "0 1 0 1";
		colors[2]     = "0 1 0 1";
		colors[3]     = "1 1 1 0.0";
			
		sizes[0]      = 2.0;
		sizes[1]      = 2.0;
		sizes[2]      = 2.0;
		sizes[3]      = 2.0;

		times[0]      = 0.0;
		times[1]      = 0.1;
		times[2]      = 0.9;
		times[3]      = 1.0;
	};
	
	%name = "boombelt_"@ %n;
	boombelt_temp.setName(%name);

	return %name;
}

boombelt_registerImage(boomBeltIcon);
boombelt_registerImage(boomBeltCI);




addDamageType("boomBelt",
	'<bitmap:Add-ons/Weapon_Better_Boombelt/boomBeltCI> %1',
	'%2 <bitmap:Add-ons/Weapon_Better_Boombelt/boomBeltCI> %1',
	0.05, 1
);

datablock explosionData(boomBeltExplosion : rocketExplosion)
{
	damageRadius = 15;
	radiusDamage = 500;
};

datablock projectileData(boomBeltProjectile : rocketLauncherProjectile) // Explosion Stuff
{
	projectileShapeName = "";
	uiName              = "";
	directDamageType    = $damageType::boomBelt;
	radiusDamageType    = $damageType::boomBelt;

	lifetime       = 0;
	explodeOnDeath = true;
	directDamage   = 100;

	explosion = boomBeltExplosion;
};

datablock itemData(boomBeltItem)
{
	category     = "item";
	shapeFile    = "./boomBelt.dts";
	mass         = 1;
	density      = 0.2;
	elasticity   = 0.2;
	friction     = 0.6;
	emap         = true;
	doColorShift = false;
	canDrop      = true;
	image        = detonatorImage;
	equipment    = true;
	
	uiName   = "Better Boombelt";
	iconName = "./boomBeltIcon";
};

datablock shapeBaseImageData(detonatorImage) // Detonator Image Stuff
{
	className    = "weaponImage";
	doColorShift = false;
	shapeFile    = "./detonator.dts";
	emap         = true;
	mountPoint   = 0;
	item         = boomBeltItem;
	offset       = "0 -0.01 0.1";
	
	correctMuzzleVector = false;
	melee               = true;
	armReady            = true;

	stateName[0]                = "activate";
	stateTimeoutValue[0]        = 0.5;
	stateTransitionOnTimeout[0] = "ready";
	stateAllowImageChange[1]    = false;

	stateName[1]                    = "ready";
	stateTransitionOnTriggerDown[1] = "fire";
	stateAllowImageChange[1]        = true;

	stateName[2]                = "fire";
	stateScript[2]              = "onFire";
	stateTimeoutValue[2]        = 1.1;
	stateTransitionOnTimeout[2] = "button_down";
	stateAllowImageChange[2]    = false;

	stateName[3]                = "button_down";
	stateSequence[3]            = "pushButton";
	stateTimeoutValue[3]        = 0.3;
	stateTransitionOnTimeout[3] = "explodeWait";
	stateAllowImageChange[3]    = false;

	stateName[4]                = "explodeWait";
	stateTimeoutValue[4]        = 0.1;
	stateTransitionOnTimeout[4] = "explodeDone";
	stateAllowImageChange[4]    = false;

	stateName[5]             = "explodeDone";
	stateAllowImageChange[5] = true;
};

datablock shapeBaseImageData(boomBeltImage)
{
	shapeFile  = "./boomBelt.dts";
	emap       = true;
	mountPoint = 7;
	
	offset    = "0 0 0.5";
	eyeOffset = "-10 0 0";
};

datablock AudioDescription(AudioClosest3dFurther : AudioClosest3d)
{
	maxDistance = 100;
	volume = 2;
};

datablock AudioProfile(boombelt_allahu_akbar)
{
	filename = "./ALLAHU_AKBAR.wav";
	description = AudioClosest3dFurther;
	preload = false;
};


function detonatorImage::onMount(%this, %obj, %slot)
{
	parent::onMount(%this, %obj, %slot);

	return %obj.mountImage(boomBeltImage, 2);
}

function detonatorImage::onUnmount(%this, %obj, %slot)
{
	return %obj.unmountImage(2);
}

function detonatorImage::onFire(%this, %obj, %slot)
{
	serverPlay3D(boombelt_allahu_akbar, getWords(%obj.getTransform(), 0, 2));
	%obj.beepSched = %obj.schedule(1350, "boombeltBeep");
	%obj.exploding = %obj.schedule(1500, "boombeltExplode");
}



package boomBelt
{
	function serverCmdunUseTool(%client)
	{
		if(isObject(%client.player) == true && isEventPending(%client.player.exploding) == true)
			return false;
		else
			return parent::serverCmdunUseTool(%client);
	}
	
	function serverCmddropTool(%client, %toolSlot)
	{
		if(isObject(%client.player) == true && isEventPending(%client.player.exploding) == true)
			return false;

		else
			return parent::serverCmddropTool(%client, %toolSlot);
	}

	function GameConnection::onDeath(%client, %a, %b, %c, %d)
	{
		//Once the beep is triggered, the explosion is inevitable
		if(isEventPending(%client.player.beepSched))
		{
			cancel(%client.player.beepSched);
			cancel(%client.player.exploding);
		}

		return Parent::onDeath(%client, %a, %b, %c, %d);
	}
};

activatePackage(boomBelt);



function Player::boombeltBeep(%this)
{
	serverPlay3D(beep_key_sound, getWords(%this.getTransform(), 0, 2));
}

function Player::boombeltExplode(%this)
{
	if(isObject(%this) == false)
		return false;

	%scaleFactor = getWord(%this.getScale(), 2);

	%p = new Projectile()
	{
		datablock = boomBeltProjectile;
		initialPosition = getWords(%this.getTransform(), 0, 2);
		sourceObject = %this;
		client = %this.client;
		sourceSlot = 0;
		originPoint = getWords(%this.getTransform(), 0, 2);
	};

	missionCleanup.add(%p);
	%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
	
	return %p;
}